<template>
    <div class="flex flex-col pb-4 bg-gray-100 dark:bg-gray-950 rounded-lg text-black dark:text-white shadow-xl dark:shadow-light-md">
        <div class="relative mt-2 my-1 mx-2">
            <div class="flex justify-between items-center md:justify-start md:space-x-10">
                <div class="lg:w-0 lg:flex-1">
                    <h3 class="font-bold text-xl">{{ name }}</h3>
                </div>
                <button class="flex-shrink pl-4 pr-2 py-1 leading-6 font-medium rounded-md bg-transparent text-green-600 hover:text-green-500 border-transparent transition ease-in-out duration-150"
                    @click="$emit('new')">
                    <feather type="plus" />
                </button>
            </div>
        </div>
        <div v-if="form" class="mx-2">
            <input-error v-for="col in Object.keys(headers)" :key="col" :message="form.error(col)" class="mt-2" />
            <action-message :on="form.recentlySuccessful" class="mr-3 mt-2">
                <span v-if="action == 'create'">Created {{ nameSingle }}</span>
                <!-- TODO: Added message (get from non-error bag) -->
            </action-message>
        </div>
        <div v-if="$slots.info" class="mx-1">
            <slot name="info" />
        </div>
        <search-box class="mx-2" :type="type" @searched="handleSearched" @searching="handleSearching" :parent="parent" />
        <table class="table-auto justify-self-center px-2" v-if="list.length > 0">
            <thead>
                <tr>
                    <th class="px-4 py-2 text-center" v-for="col in Object.values(headers)" :key="col">{{ col }}</th>
                </tr>
            </thead>
            <tbody>
                <tr v-for="item in list" :key="item.id" class="hover:bg-yellow-100 dark:hover:bg-yellow-500 transition-colors duration-200" @click="$emit('click', item.id)">
                    <td class="px-4 py-2 text-center" v-for="col in Object.keys(headers)" :key="col">{{ resolveAttr(item,col) || 'None' }}</td>
                </tr>
            </tbody>
        </table>
        <div v-else class="mx-4 text-center">
            <span v-if="searching" class="text-red-800 dark:text-red-300">No {{ name }} found</span>
            <span v-else>No {{ name }}</span>
        </div>
    </div>
</template>

<script>
import SearchBox from './SearchBox'
import pluralize from 'pluralize';
export default {
    components: {
        SearchBox,
    },
    props: {
        name: {
            type: String,
            required: true,
        },
        type: {
            type: String,
            required: true,
        },
        headers: {
            type: Object, // key in data: nice name
            required: true,
        },
        data: {
            type: Array,
            default: () => [],
        },
        form: {
            type: Object,
        },
        action: {
            type: String,
            default: 'create',
        },
        parent: {
            type: [Number, String],
            default: null,
        },
    },
    data() {
        return {
            list: this.data,
            searching: false,
            nameSingle: pluralize.singular(this.name),
        }
    },
    methods: {
        handleSearched(results){
            this.list = results;
        },
        handleSearching(isSearching){
            this.searching = isSearching;
            if(isSearching == false) {
                this.list = this.data;
            }
        },
        resolveAttr(item,attr){
            if(attr.includes('.')){
                let ret = item;
                attr.split('.').forEach(a => {
                    ret = ret[a];
                });
                return ret;
            } else {
                return item[attr];
            }
        }
    }
}
</script>